%%    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%        
function b=NonOverlap(top,a,percent_allow)
    global gap1; global gap2;
    if isempty(a)               , b=a; return; end;
    if (nargin < 3)             , percent_allow =0.1;    end;
    s = 1-percent_allow;
    b = zeros(top+1,size(a,2));
    a=sortrows(a);
    na = size(a,1);
    i=1; k=1;
    
    if (a(i,3) < a(i,5))
        b(k,:)=a(i,:);                                   
    else
        b(k,:)=[a(i,1) a(i,4) a(i,5) a(i,2) a(i,3) a(i,6)];               
    end
    
    while ((i<=na)&&(k<=top))           %% Note: O(na^2)
        overlap = false;
        for j=1:k
           if (((abs(a(i,2)-b(j,2))<=gap1*s)&&abs(a(i,3)-b(j,3))<=gap2*s  || ...
                (abs(a(i,4)-b(j,4))<=gap1*s)&&abs(a(i,5)-b(j,5))<=gap2*s) || ...
               ((abs(a(i,2)-b(j,4))<=gap1*s)&&abs(a(i,3)-b(j,5))<=gap2*s  || ...
                (abs(a(i,4)-b(j,2))<=gap1*s)&&abs(a(i,5)-b(j,3))<=gap2*s) )     
               overlap = true;
               break;
           end
        end
        if (overlap == false)
           k=k+1;        
           
           if (a(i,3) < a(i,5))
               b(k,:)=a(i,:);                                   
           else
               b(k,:)=[a(i,1) a(i,4) a(i,5) a(i,2) a(i,3) a(i,6)];               
           end
        end            
        i=i+1;
    end
    b=b(1:min(top,k),:);
% % disp('xxx');

